
define(e1,10)
define(e2,10)
define(e3,8)
define(e4,5)
define(e5,15)
define(e6,15)
define(e7,15)
define(e8,20)
define(e9,15)
define(e10,20)
define(e11,20)
define(e12,5)

define(p1,200)
define(p2,200)
define(p3,100)
define(p4,100)
define(p5,100)
define(p6,100)
define(p7,100)
define(p8,50)
define(p9,100)
define(p10,100)
define(p11,100)
define(p12,50)

define(d1,400)
define(d2,400)
define(d3,100)
define(d4,100)
define(d5,100)
define(d6,100)
define(d7,100)
define(d8,50)
define(d9,100)
define(d10,100)
define(d11,100)
define(d12,50)

automata A: i=1..10;
clock    x[1..total(A)];
clock    y[1..total(A)];
register p;
register c16, c27, c35, c46, c47, c4A, c56, c58, 
         c68, c76, c78, c8C, c8A, c9A, cA8, cAB;

--------------------------------------------------------------------------
automaton A[i] {
initially I and c16 = 0 & c27 = 0 & c35 = 0 & c46 = 0 & 
                c47 = 0 & c4A = 0 & c56 = 0 & c58 = 0 & 
                c68 = 0 & c76 = 0 & c78 = 0 & c8C = 0 &
                c8A = 0 & c9A = 0 & cA8 = 0 & cAB = 0
            and x[i] = 0;
  mode I{ 
    invariant True;
    when True may goto E; p := i;
  }
  mode E{ 
    invariant True;
    when p = 1 and x[i] = e1 may goto D; c16 := 1;
    when p = 2 and x[i] = e2 may goto D; c27 := 1;
    when p = 3 and x[i] = e3 may goto D; c35 := 1;
    when p = 4 and x[i] = e4 may goto D; c46 := 1; c47 := 1; c4A := 1;
    when p = 5 & c35 = 1 and x[i] = e5 may goto D; c35 := 0; c56 := 1; c58 := 1;
    when p = 5 & c35 = 0 and x[i] = e5 may goto D;
    when p = 6 & c16 = 1 | c46 = 1 | c56 = 1 | c76 = 1 and x[i] = e6 may goto D;
         c16 := 0; c46 := 0; c56 := 0; c76 := 0; c68 := 1;
    when p = 6 & c16 = 0 & c46 = 0 & c56 = 0 & c76 = 0 and x[i] = e6 may goto D;
    when p = 7 & c27 = 1 | c47 = 1 and x[i] = e7 may goto D;
         c27 := 0; c47 := 0; c76 := 1; c78 := 1;
    when p = 7 & c27 = 0 & c47 = 0 and x[i] = e7 may goto D;
    when p = 8 & c58 = 1 | c68 = 1 | c78 = 1 | cA8 = 1 and x[i] = e8 may goto D;
         c58 := 0; c68 := 0; c78 := 0; cA8 := 0; c8C := 1; c8A := 1;
    when p = 8 & c58 = 0 & c68 = 0 & c78 = 0 & cA8 = 0 and x[i] = e8 may goto D;
    when p = 9 and x[i] = e9 may goto D; c9A := 1;
    when p = 10 & c4A = 1 | c8A = 1 | c9A = 1 and x[i] = e10 may goto D; 
         cA8 := 1; cAB := 1;
    when p = 10 & c4A = 0 & c8A = 0 & c9A = 0 and x[i] = e10 may goto D; 
  }
  mode D{ 
    invariant True;
    when p = 1 and x[i] >= p1 may goto R; y[i] := 0;
    when p = 2 and x[i] >= p2 may goto R; y[i] := 0;
    when p = 3 and x[i] >= p3 may goto R; y[i] := 0;
    when p = 4 and x[i] >= p4 may goto R; y[i] := 0;
    when p = 5 and x[i] >= p5 may goto R; y[i] := 0;
    when p = 6 and x[i] >= p6 may goto R; y[i] := 0;
    when p = 7 and x[i] >= p7 may goto R; y[i] := 0;
    when p = 8 and x[i] >= p8 may goto R; y[i] := 0;
    when p = 9 and x[i] >= p9 may goto R; y[i] := 0;
    when p = 10 and x[i] >= p10 may goto R; y[i] := 0;
  }
  mode R{
    invariant y[i] = 0;
    when p = 1 and x[i] > d1 may goto V;
    when p = 2 and x[i] > d2 may goto V;
    when p = 3 and x[i] > d3 may goto V;
    when p = 4 and x[i] > d4 may goto V;
    when p = 5 and x[i] > d5 may goto V;
    when p = 6 and x[i] > d6 may goto V;
    when p = 7 and x[i] > d7 may goto V;
    when p = 8 and x[i] > d8 may goto V;
    when p = 9 and x[i] > d9 may goto V;
    when p = 10 and x[i] > d10 may goto V;
    when p = 1 and x[i] <= d1 may goto I;
    when p = 2 and x[i] <= d2 may goto I;
    when p = 3 and x[i] <= d3 may goto I;
    when p = 4 and x[i] <= d4 may goto I;
    when p = 5 and x[i] <= d5 may goto I;
    when p = 6 and x[i] <= d6 may goto I;
    when p = 7 and x[i] <= d7 may goto I;
    when p = 8 and x[i] <= d8 may goto I;
    when p = 9 and x[i] <= d9 may goto I;
    when p = 10 and x[i] <= d10 may goto I;
  }
  mode V{
    invariant True;
  }
}

--verify all_paths (henceforth not{(mode(A[1]) = M4) and (mode(A[2]) = M4)}
--                         and not{(mode(A[1]) = M4) and (mode(A[3]) = M4)}
--                         and not{(mode(A[2]) = M4) and (mode(A[3]) = M4)}
--                 );

manipulation

----------------------------------------
--   A user-defined sequential merge  --
----------------------------------------
--    graph g[1..3];
--
--    for(i:=1; i<4; i++) {
--      if(i = 1) {
--        g[1] := merge_graph(A[1], A[2]);
--      }
--      else {
--        g[i] := merge_graph(g[i-1], A[i+1]);
--      }
--    }
--    read_write(g[i-1]);
--    shield_clock(g[i-1]);
--    normalize_region(g[i-1]);
--
--    model_check(g[total_automata-1]);
--    print_graph(g[total_automata-1]);
----------------------------------------

----------------------------------------
--   System-defined sequential merge  --
----------------------------------------
    sequential_merge();
--    read_write();
--    shield_clock();
--    normalize_region();
--    transition_bypass();   -- No use
--    print_graph();
