
define(e1,10)
define(e2,10)
define(e3,8)
define(e4,5)
define(e5,15)
define(e6,15)
define(e7,15)
define(e8,15)
define(e9,20)
define(e10,20)
define(e11,5)

define(p1,200)
define(p2,200)
define(p3,100)
define(p4,100)
define(p5,100)
define(p6,100)
define(p7,100)
define(p8,100)
define(p9,100)
define(p10,100)
define(p11,50)

define(d1,400)
define(d2,400)
define(d3,100)
define(d4,100)
define(d5,100)
define(d6,100)
define(d7,100)
define(d8,100)
define(d9,100)
define(d10,100)
define(d11,50)

automata A: i=1..11;
clock    x[1..total(A)];
clock    y[1..total(A)];
register p, t;

--------------------------------------------------------------------------
automaton A[i] {
initially I and t = 11 and x[i] = 0;
  mode I{ 
    invariant True;
    when t = i may goto E; p := i;
  }
  mode E{ 
    invariant True;
    when p = 1 and x[i] = e1 may goto D; t := 11;
    when p = 2 and x[i] = e2 may goto D; t := 1;
    when p = 3 and x[i] = e3 may goto D; t := 2;
    when p = 4 and x[i] = e4 may goto D; t := 3;
    when p = 5 and x[i] = e5 may goto D; t := 4;
    when p = 6 and x[i] = e6 may goto D; t := 5;
    when p = 7 and x[i] = e7 may goto D; t := 6;
    when p = 8 and x[i] = e8 may goto D; t := 7;
    when p = 9 and x[i] = e9 may goto D;  t := 8;
    when p = 10 and x[i] = e10 may goto D; t := 9;
    when p = 11 and x[i] = e11 may goto D; t := 10;
  }
  mode D{ 
    invariant True;
    when p = 1 and x[i] >= p1 may goto R; y[i] := 0;
    when p = 2 and x[i] >= p2 may goto R; y[i] := 0;
    when p = 3 and x[i] >= p3 may goto R; y[i] := 0;
    when p = 4 and x[i] >= p4 may goto R; y[i] := 0;
    when p = 5 and x[i] >= p5 may goto R; y[i] := 0;
    when p = 6 and x[i] >= p6 may goto R; y[i] := 0;
    when p = 7 and x[i] >= p7 may goto R; y[i] := 0;
    when p = 8 and x[i] >= p8 may goto R; y[i] := 0;
    when p = 9 and x[i] >= p9 may goto R; y[i] := 0;
    when p = 10 and x[i] >= p10 may goto R; y[i] := 0;
    when p = 11 and x[i] >= p11 may goto R; y[i] := 0;
  }
  mode R{
    invariant y[i] = 0;
    when p = 1 and x[i] > d1 may goto V;
    when p = 2 and x[i] > d2 may goto V;
    when p = 3 and x[i] > d3 may goto V;
    when p = 4 and x[i] > d4 may goto V;
    when p = 5 and x[i] > d5 may goto V;
    when p = 6 and x[i] > d6 may goto V;
    when p = 7 and x[i] > d7 may goto V;
    when p = 8 and x[i] > d8 may goto V;
    when p = 9 and x[i] > d9 may goto V;
    when p = 10 and x[i] > d10 may goto V;
    when p = 11 and x[i] > d11 may goto V;
    when p = 1 and x[i] <= d1 may goto I;
    when p = 2 and x[i] <= d2 may goto I;
    when p = 3 and x[i] <= d3 may goto I;
    when p = 4 and x[i] <= d4 may goto I;
    when p = 5 and x[i] <= d5 may goto I;
    when p = 6 and x[i] <= d6 may goto I;
    when p = 7 and x[i] <= d7 may goto I;
    when p = 8 and x[i] <= d8 may goto I;
    when p = 9 and x[i] <= d9 may goto I;
    when p = 10 and x[i] <= d10 may goto I;
    when p = 11 and x[i] <= d11 may goto I;
  }
  mode V{
    invariant True;
  }
}

--verify all_paths (henceforth not{(mode(A[1]) = M4) and (mode(A[2]) = M4)}
--                         and not{(mode(A[1]) = M4) and (mode(A[3]) = M4)}
--                         and not{(mode(A[2]) = M4) and (mode(A[3]) = M4)}
--                 );

manipulation

----------------------------------------
--   A user-defined sequential merge  --
----------------------------------------
--    graph g[1..3];
--
--    for(i:=1; i<4; i++) {
--      if(i = 1) {
--        g[1] := merge_graph(A[1], A[2]);
--      }
--      else {
--        g[i] := merge_graph(g[i-1], A[i+1]);
--      }
--    }
--    read_write(g[i-1]);
--    shield_clock(g[i-1]);
--    normalize_region(g[i-1]);
--
--    model_check(g[total_automata-1]);
--    print_graph(g[total_automata-1]);
----------------------------------------

----------------------------------------
--   System-defined sequential merge  --
----------------------------------------
    sequential_merge();
    read_write();
    shield_clock();
    normalize_region();
--    transition_bypass();   -- No use
--    print_graph();
