


automata P : i = 1..2;
clock x[1..2];
register Count;

--------------------------------------------------------------------------
automaton P[i] {
initially Init and Count = 5 and x[i] = 0;
  mode Init {
    invariant True;
    when True may goto Poll; x[i] := 0;
  }
  mode Poll{
    invariant x[i] <= 1;
    when Count > 0 and x[i] = 1 may goto CarIn; x[i] := 0;
    when Count < 5 and x[i] = 1 may goto CarOut; x[i] := 0;
    when x[i] = 1 may goto Check; x[i] := 0;
  }
  mode CarIn{ 
    invariant x[i] <= 1;
    when x[i] = 1 may goto Init2; Count := Count - 1 (mod 6);
                                                x[i] := 0;
  }
  mode CarOut{
    invariant x[i] <= 1;
    when x[i] = 1 may goto Init2; Count := Count + 1 (mod 6); 
                                                x[i] := 0;
  }
  mode Check{
    invariant x[i] < 1;
    when x[i] < 1 may goto Init2; x[i] := 0;
  }
  mode Init2 {
    invariant True;
    when True may goto Poll2; x[i] := 0;
  }
  mode Poll2{
    invariant x[i] <= 1;
    when Count > 0 and x[i] = 1 may goto CarIn2; x[i] := 0;
    when Count < 5 and x[i] = 1 may goto CarOut2; x[i] := 0;
    when x[i] = 1 may goto Check2; x[i] := 0;
  }
  mode CarIn2{ 
    invariant x[i] <= 1;
    when x[i] = 1 may goto Init; Count := Count - 1 (mod 6);
                                                x[i] := 0;
  }
  mode CarOut2{
    invariant x[i] <= 1;
    when x[i] = 1 may goto Init; Count := Count + 1 (mod 6); 
                                                x[i] := 0;
  }
  mode Check2{
    invariant x[i] < 1;
    when x[i] < 1 may goto Init; x[i] := 0;
  }
}

manipulation
--    graph g[1..3];
--
--    g[1] := merge_graph(P[1], P[2]);
--    read_write(g[1]);
--    shield_clock(g[1]);
--    normalize_region(g[1]);
--    g[2] := merge_graph(Q[3], Q[4]);
--    read_write(g[2]);
--    shield_clock(g[2]);
--    normalize_region(g[2]);
--    g[3] := merge_graph(g[1], g[2]);
--    read_write(g[3]);
--    shield_clock(g[3]);
--    normalize_region(g[3]);

----------------------------------------
--   System-defined sequential merge  --
----------------------------------------
    sequential_merge();
    read_write();
    shield_clock();
--    normalize_region();
--    transition_bypass();   -- No use
--    print_graph();
