automata P2, P3, P1, T1, STARTs2, s1s4;

clock Pt3, Pt2, Pt1, Tt1;


automaton P2 {
synclabs sSs4,sSs2,sEs2,sEs4;
initially IDLE and Pt3=0;
mode IDLE {
 invariant True ;
          when True sync sSs4  may goto s4;
                  Pt3 := 0;
          when True sync sSs2  may goto s2;
                  Pt3 := 0;
}
mode s2 {
 invariant True ;
          when Pt3 = 1 sync sEs2  may goto IDLE;
                  Pt3 :=0;
}
mode s4 {
 invariant True ;
          when Pt3 = 1 sync sEs4  may goto IDLE;
                  Pt3 :=0;
}
}

automaton P3 {
synclabs sSs3,sEs3;
initially IDLE and Pt2=0;
mode IDLE {
 invariant True ;
          when True sync sSs3  may goto s3;
                  Pt2 := 0;
}
mode s3 {
 invariant True ;
          when Pt2 = 1 sync sEs3  may goto IDLE;
                  Pt2 :=0;
}
}

automaton P1 {
synclabs sSs1,sEs1;
initially IDLE and Pt1=0;
mode IDLE {
 invariant True ;
          when True sync sSs1  may goto s1;
                  Pt1 := 0;
}
mode s1 {
 invariant True ;
          when Pt1 = 1 sync sEs1  may goto IDLE;
                  Pt1 :=0;
}
}

automaton T1 {
synclabs sFSTART2,sSs1,sEs1,sFs12,sJs32,sSs3,sEs3,sJEND2;
initially START and  Tt1=0;
mode START {
 invariant True ;
          when True sync sFSTART2  may goto FSTART2;
}
mode FSTART2 {
 invariant True ;
          when True sync sSs1  may goto Ss1;
}
mode Ss1 {
 invariant True ;
          when True sync sEs1  may goto Es1;
}
mode Es1 {
 invariant True ;
          when True sync sFs12  may goto Fs12;
}
mode Fs12 {
 invariant True ;
          when True sync sJs32 may goto Js32;
}
mode Js32 {
 invariant True ;
          when True sync sSs3 may goto Ss3;
}
mode Ss3 {
 invariant True ;
          when True sync sEs3  may goto Es3;
}
mode Es3 {
 invariant True ;
          when True sync sJEND2  may goto JEND2;
}
mode JEND2 {
 invariant True ;
          when Tt1 <= 7 may goto DELAY;
          when Tt1 > 7 may goto lERROR;
}
mode DELAY {
 invariant True ;
          when Tt1=7  may goto START;
                  Tt1 := 0;
}
mode lERROR {
 invariant True ;
          when False may goto lERROR;
}
}

automaton STARTs2 {
synclabs sFSTART2,sSs2,sEs2,sJs32;
initially IDLE ;
mode IDLE {
 invariant True ;
          when True sync sFSTART2  may goto START;
}
mode START {
 invariant True ;
          when True sync sSs2  may goto Ss2;
}
mode Ss2 {
 invariant True ;
          when True sync sEs2  may goto Es2;
}
mode Es2 {
 invariant True ;
          when True sync sJs32 may goto IDLE;
}
}

automaton s1s4 {
synclabs sFs12,sSs4,sEs4,sJEND2;
initially IDLE ;
mode IDLE {
 invariant True ;
          when True sync sFs12 may goto START;
}
mode START {
 invariant True ;
          when True sync sSs4 may goto Ss4;
}
mode Ss4 {
 invariant True ;
          when True sync sEs4  may goto Es4;
}
mode Es4 {
 invariant True ;
          when True sync sJEND2 may goto IDLE;
}
}

 manipulation 
  sequential_merge();
