total_automata 5;
clock x[1..total_automata];
register lock;

--------------------------------------------------------------------------
automaton A[i] {
initially M1 and lock = 0 and x[i] = 0;
  mode M1 { 
    invariant x[i] >= 0;
    when x[i] >= 0 and lock = 0 may goto M2; x[i] := 0;
  }
  mode M2{ 
    invariant x[i] < 1;
    when x[i] < 1 may goto M3; x[i] := 0; lock := i;
  }
  mode M3{ 
    invariant x[i] <= 1;
    when x[i] >= 1 and lock = i may goto M4; x[i] := 0;
    when x[i] >= 1 and ~(lock = i) may goto M1; x[i] := 0;
  }
  mode M4{
    invariant x[i] >= 0 and lock = i;
    when x[i] > 0 may goto M1; lock := 0; x[i] := 0;
  }
}
