automata Z, X, T1, T2, T2D2, T2D3, dfD2, dfD3, df;

register Pt2, Pt1, Tt1, Tt2, Tt3, Tt4;


automaton Z {
synclabs sSf,sSfD2,sSfD3,sSa,sSc,sEc,sEa,sEfD3,sEfD2,sEf;
initially IDLE and Pt2=0;
mode IDLE {
 invariant True ;
          when True sync sSf  may goto f;
                  Pt2 := 0;
          when True sync sSfD2  may goto fD2;
                  Pt2 :=0;
          when True sync sSfD3  may goto fD3;
                  Pt2 :=0;
          when True sync sSa  may goto a;
                  Pt2 := 0;
          when True sync sSc  may goto c;
                  Pt2 := 0;
}
mode c {
 invariant True ;
          when Pt2 = 13 sync sEc  may goto IDLE;
                  Pt2 :=0;
}
mode a {
 invariant True ;
          when Pt2 = 20 sync sEa  may goto IDLE;
                  Pt2 :=0;
}
mode fD3 {
 invariant True ;
          when Pt2 = 9 sync sEfD3  may goto IDLE;
                  Pt2 := 0;
}
mode fD2 {
 invariant True ;
          when Pt2 = 9 sync sEfD2  may goto IDLE;
                  Pt2 := 0;
}
mode f {
 invariant True ;
          when Pt2 = 9 sync sEf  may goto IDLE;
                  Pt2 :=0;
}
}

automaton X {
synclabs sSd,sSdD2,sSdD3,sSe,sSeD2,sSeD3,sSb,sEb,sEeD3,sEeD2,sEe,sEdD3,sEdD2,sEd;
initially IDLE and Pt1=0;
mode IDLE {
 invariant True ;
          when True sync sSd  may goto d;
                  Pt1 := 0;
          when True sync sSdD2  may goto dD2;
                  Pt1 :=0;
          when True sync sSdD3  may goto dD3;
                  Pt1 :=0;
          when True sync sSe  may goto e;
                  Pt1 := 0;
          when True sync sSeD2  may goto eD2;
                  Pt1 :=0;
          when True sync sSeD3  may goto eD3;
                  Pt1 :=0;
          when True sync sSb  may goto b;
                  Pt1 := 0;
}
mode b {
 invariant True ;
          when Pt1 = 10 sync sEb  may goto IDLE;
                  Pt1 :=0;
}
mode eD3 {
 invariant True ;
          when Pt1 = 36 sync sEeD3  may goto IDLE;
                  Pt1 := 0;
}
mode eD2 {
 invariant True ;
          when Pt1 = 36 sync sEeD2  may goto IDLE;
                  Pt1 := 0;
}
mode e {
 invariant True ;
          when Pt1 = 36 sync sEe  may goto IDLE;
                  Pt1 :=0;
}
mode dD3 {
 invariant True ;
          when Pt1 = 21 sync sEdD3  may goto IDLE;
                  Pt1 := 0;
}
mode dD2 {
 invariant True ;
          when Pt1 = 21 sync sEdD2  may goto IDLE;
                  Pt1 := 0;
}
mode d {
 invariant True ;
          when Pt1 = 21 sync sEd  may goto IDLE;
                  Pt1 :=0;
}
}

automaton T1 {
synclabs sSa,sEa,sSb,sEb,sSc,sEc;
initially START and  Tt1=0;
mode START {
 invariant True ;
          when True sync sSa  may goto Sa;
}
mode Sa {
 invariant True ;
          when True sync sEa  may goto Ea;
}
mode Ea {
 invariant True ;
          when True sync sSb may goto Sb;
}
mode Sb {
 invariant True ;
          when True sync sEb  may goto Eb;
}
mode Eb {
 invariant True ;
          when True sync sSc may goto Sc;
}
mode Sc {
 invariant True ;
          when True sync sEc  may goto Ec;
}
mode Ec {
 invariant True ;
          when True & Tt1 <= 46 may goto DELAY;
          when True & Tt1 > 46 may goto lERROR;
}
mode DELAY {
 invariant True ;
          when Tt1=280  may goto START;
                  Tt1 := 0;
}
mode lERROR {
 invariant True ;
          when False may goto lERROR;
}
}

automaton T2 {
synclabs sSd,sEd,sFd2,sSe,sEe,sJEND2;
initially START and  Tt2=0;
mode START {
 invariant True ;
          when True sync sSd  may goto Sd;
}
mode Sd {
 invariant True ;
          when True sync sEd  may goto Ed;
}
mode Ed {
 invariant True ;
          when True sync sFd2  may goto Fd2;
}
mode Fd2 {
 invariant True ;
          when True sync sSe may goto Se;
}
mode Se {
 invariant True ;
          when True sync sEe  may goto Ee;
}
mode Ee {
 invariant True ;
          when True sync sJEND2  may goto JEND2;
}
mode JEND2 {
 invariant True ;
          when True & Tt2 <= 186 may goto DELAY;
          when True & Tt2 > 186 may goto lERROR;
}
mode DELAY {
 invariant True ;
          when Tt2=228  may goto START;
                  Tt2 := 0;
}
mode lERROR {
 invariant True ;
          when False may goto lERROR;
}
}

automaton T2D2 {
synclabs sSdD2,sEdD2,sFd2D2,sSeD2,sEeD2,sJEND2D2;
initially DELAY and Tt3=76;
mode START {
 invariant True ;
          when True sync sSdD2 may goto SdD2;
}
mode SdD2 {
 invariant True ;
          when True sync sEdD2 may goto EdD2;
}
mode EdD2 {
 invariant True ;
          when True sync sFd2D2 may goto Fd2D2;
}
mode Fd2D2 {
 invariant True ;
          when True sync sSeD2 may goto SeD2;
}
mode SeD2 {
 invariant True ;
          when True sync sEeD2 may goto EeD2;
}
mode EeD2 {
 invariant True ;
          when True sync sJEND2D2 may goto JEND2D2;
}
mode JEND2D2 {
 invariant True ;
          when True & Tt3 <= 186 may goto DELAY;
          when True & Tt3 > 186 may goto lERROR;
}
mode DELAY {
 invariant True ;
          when Tt3=228  may goto START;
                  Tt3 := 0;
}
mode lERROR {
 invariant True ;
          when False may goto lERROR;
}
}

automaton T2D3 {
synclabs sSdD3,sEdD3,sFd2D3,sSeD3,sEeD3,sJEND2D3;
initially DELAY and Tt4=152;
mode START {
 invariant True ;
          when True sync sSdD3 may goto SdD3;
}
mode SdD3 {
 invariant True ;
          when True sync sEdD3 may goto EdD3;
}
mode EdD3 {
 invariant True ;
          when True sync sFd2D3 may goto Fd2D3;
}
mode Fd2D3 {
 invariant True ;
          when True sync sSeD3 may goto SeD3;
}
mode SeD3 {
 invariant True ;
          when True sync sEeD3 may goto EeD3;
}
mode EeD3 {
 invariant True ;
          when True sync sJEND2D3 may goto JEND2D3;
}
mode JEND2D3 {
 invariant True ;
          when True & Tt4 <= 186 may goto DELAY;
          when True & Tt4 > 186 may goto lERROR;
}
mode DELAY {
 invariant True ;
          when Tt4=228  may goto START;
                  Tt4 := 0;
}
mode lERROR {
 invariant True ;
          when False may goto lERROR;
}
}

automaton dfD2 {
synclabs sFd2D2,sSfD2,sEfD2,sJEND2D2;
initially IDLE ;
mode IDLE {
 invariant True ;
          when True sync sFd2D2 may goto START;
}
mode START {
 invariant True ;
          when True sync sSfD2 may goto SfD2;
}
mode SfD2 {
 invariant True ;
          when True sync sEfD2 may goto EfD2;
}
mode EfD2 {
 invariant True ;
          when True sync sJEND2D2 may goto IDLE;
}
}

automaton dfD3 {
synclabs sFd2D3,sSfD3,sEfD3,sJEND2D3;
initially IDLE ;
mode IDLE {
 invariant True ;
          when True sync sFd2D3 may goto START;
}
mode START {
 invariant True ;
          when True sync sSfD3 may goto SfD3;
}
mode SfD3 {
 invariant True ;
          when True sync sEfD3 may goto EfD3;
}
mode EfD3 {
 invariant True ;
          when True sync sJEND2D3 may goto IDLE;
}
}

automaton df {
synclabs sFd2,sSf,sEf,sJEND2;
initially IDLE ;
mode IDLE {
 invariant True ;
          when True sync sFd2 may goto START;
}
mode START {
 invariant True ;
          when True sync sSf may goto Sf;
}
mode Sf {
 invariant True ;
          when True sync sEf  may goto Ef;
}
mode Ef {
 invariant True ;
          when True sync sJEND2 may goto IDLE;
}
}

 manipulation 
  sequential_merge();
