automata Client1 : i = 1, Client2 : j = 2, Client3 : k = 3;
clock x[1..3];
register token[1..3];

--------------------------------------------------------------------------
automaton Client1 {
initially Idle and 
          token[i] = 1 and
          x[i] = 0;
  mode Idle {
    invariant True;
    when x[i] >= 1 and token[i] = 1 may goto CS;
  }
  mode CS{
    invariant True; 
    when True may goto Idle; x[i] := 0; token[i] := 0; token[j] := 1;
  }
}

automaton Client2 {
initially Idle and token[j] = 0 and x[j] = 0;
  mode Idle {
    invariant True;
    when x[j] >= 1 and token[j] = 1 may goto CS;
  }
  mode CS{
    invariant True; 
    when True may goto Idle; x[j] := 0; token[j] := 0; token[k] := 1;
  }
}

automaton Client3 {
initially Idle and token[k] = 0 and x[k] = 0;
  mode Idle {
    invariant True;
    when x[k] >= 1 and token[k] = 1 may goto CS;
  }
  mode CS{
    invariant True; 
    when True may goto Idle; x[k] := 0; token[k] := 0; token[i] := 1;
  }
}

manipulation

----------------------------------------
--   System-defined sequential merge  --
----------------------------------------
    sequential_merge();
--    shield_clock();
    read_write();
    transition_bypass();
--    normalize_region();
--    look_ahead();
--      pairwise_merge();
--    print_graph();
--    model_check();
