automata A : i = 1..10;
register P;

--------------------------------------------------------------------------
automaton A[i] {
initially M1 and P = 1;
  mode M1 { 
    invariant P = 1;
    when P = 1 may goto M2;
  }
  mode M2{ 
    invariant True;
  }
}

manipulation

----------------------------------------
--   A user-defined sequential merge  --
----------------------------------------
--    graph g[1..total_automata-1];
--
--    for(i:=1; i<total_automata; i++) {
--      if(i = 1) {
--        g[1] := merge_graph(A[1], A[2]);
--      }
--      else {
--        g[i] := merge_graph(g[i-1], A[i+1]);
--      }
--      look_ahead(g[i-1], g[i]);
--      shield_clock(g[i]);
--      normalize_region(g[i]);
--    }
--    model_check(g[total_automata-1]);
--    print_graph(g[total_automata-1]);
----------------------------------------

----------------------------------------
--   System-defined sequential merge  --
----------------------------------------
    sequential_merge();
    transition_bypass();
--      pairwise_merge();
--    look_ahead();
--    read_write();
--    shield_clock();
--    normalize_region();
--    print_graph();
--    model_check();
