




































automata A: i=1..11;
clock    x[1..total(A)];
clock    y[1..total(A)];
register p;
register c16, c27, c35, c46, c47, c49, c56, c59, c5B,
         c69, c6B, c76, c79, c7B, c89, c9A;

--------------------------------------------------------------------------
automaton A[i] {
initially I and c16 = 0 & c27 = 0 & c35 = 0 & c46 = 0 & 
                c47 = 0 & c49 = 0 & c56 = 0 & c59 = 0 & 
                c5B = 0 & c69 = 0 & c6B = 0 & c76 = 0 & 
                c79 = 0 & c7B = 0 & c89 = 0 & c9A = 0
            and x[i] = 0;
  mode I{ 
    invariant True;
    when True may goto E; p := i;
  }
  mode E{ 
    invariant True;
    when p = 1 and x[i] = 10 may goto D; c16 := 1;
    when p = 2 and x[i] = 10 may goto D; c27 := 1;
    when p = 3 and x[i] = 8 may goto D; c35 := 1;
    when p = 4 and x[i] = 5 may goto D; c46 := 1; c47 := 1; c49 := 1;
    when p = 5 and x[i] = 15 may goto D; c35 := 0; c56 := 1; c59 := 1; c5B := 1;
    when p = 6 and x[i] = 15 may goto D;
         c16 := 0; c46 := 0; c56 := 0; c76 := 0; c69 := 1; c6B := 1;
    when p = 7 and x[i] = 15 may goto D;
         c27 := 0; c47 := 0; c76 := 1; c79 := 1; c7B := 1;
    when p = 8 and x[i] = 15 may goto D; c89 := 1;
    when p = 9 and x[i] = 20 may goto D; 
         c49 := 0; c59 := 0; c69 := 0; c79 := 0; c89 := 0; c9A := 1;
    when p = 10 and x[i] = 20 may goto D; c9A := 0;
    when p = 11 and x[i] = 5 may goto D; c5B := 0; c6B := 0; c7B := 0;
  }
  mode D{ 
    invariant True;
    when p = 1 and x[i] >= 200 may goto R; y[i] := 0;
    when p = 2 and x[i] >= 200 may goto R; y[i] := 0;
    when p = 3 and x[i] >= 100 may goto R; y[i] := 0;
    when p = 4 and x[i] >= 100 may goto R; y[i] := 0;
    when p = 5 and x[i] >= 100 may goto R; y[i] := 0;
    when p = 6 and x[i] >= 100 may goto R; y[i] := 0;
    when p = 7 and x[i] >= 100 may goto R; y[i] := 0;
    when p = 8 and x[i] >= 100 may goto R; y[i] := 0;
    when p = 9 and x[i] >= 100 may goto R; y[i] := 0;
    when p = 10 and x[i] >= 100 may goto R; y[i] := 0;
    when p = 11 and x[i] >= 50 may goto R; y[i] := 0;
  }
  mode R{
    invariant y[i] = 0;
    when p = 1 and x[i] > 400 may goto V;
    when p = 2 and x[i] > 400 may goto V;
    when p = 3 and x[i] > 100 may goto V;
    when p = 4 and x[i] > 100 may goto V;
    when p = 5 and x[i] > 100 may goto V;
    when p = 6 and x[i] > 100 may goto V;
    when p = 7 and x[i] > 100 may goto V;
    when p = 8 and x[i] > 100 may goto V;
    when p = 9 and x[i] > 100 may goto V;
    when p = 10 and x[i] > 100 may goto V;
    when p = 11 and x[i] > 50 may goto V;
    when p = 1 and x[i] <= 400 may goto I;
    when p = 2 and x[i] <= 400 may goto I;
    when p = 3 and x[i] <= 100 may goto I;
    when p = 4 and x[i] <= 100 may goto I;
    when p = 5 and x[i] <= 100 may goto I;
    when p = 6 and x[i] <= 100 may goto I;
    when p = 7 and x[i] <= 100 may goto I;
    when p = 8 and x[i] <= 100 may goto I;
    when p = 9 and x[i] <= 100 may goto I;
    when p = 10 and x[i] <= 100 may goto I;
    when p = 11 and x[i] <= 50 may goto I;
  }
  mode V{
    invariant True;
  }
}

--verify all_paths (henceforth not{(mode(A[1]) = M4) and (mode(A[2]) = M4)}
--                         and not{(mode(A[1]) = M4) and (mode(A[3]) = M4)}
--                         and not{(mode(A[2]) = M4) and (mode(A[3]) = M4)}
--                 );

manipulation

----------------------------------------
--   A user-defined sequential merge  --
----------------------------------------
--    graph g[1..3];
--
--    for(i:=1; i<4; i++) {
--      if(i = 1) {
--        g[1] := merge_graph(A[1], A[2]);
--      }
--      else {
--        g[i] := merge_graph(g[i-1], A[i+1]);
--      }
--    }
--    read_write(g[i-1]);
--    shield_clock(g[i-1]);
--    normalize_region(g[i-1]);
--
--    model_check(g[total_automata-1]);
--    print_graph(g[total_automata-1]);
----------------------------------------

----------------------------------------
--   System-defined sequential merge  --
----------------------------------------
    sequential_merge();
    read_write();
    shield_clock();
    normalize_region();
--    transition_bypass();   -- No use
--    print_graph();
