
define(e1,1)
define(e2,1)
define(e3,1)
define(e4,1)
define(e5,2)
define(e6,2)
define(e7,2)
define(e8,2)
define(e9,2)
define(e10,2)
define(e11,1)

define(p1,20)
define(p2,20)
define(p3,10)
define(p4,10)
define(p5,10)
define(p6,10)
define(p7,10)
define(p8,10)
define(p9,10)
define(p10,10)
define(p11,5)

define(d1,40)
define(d2,40)
define(d3,10)
define(d4,10)
define(d5,10)
define(d6,10)
define(d7,10)
define(d8,10)
define(d9,10)
define(d10,10)
define(d11,5)

automata A: i=1..11;
clock    x[1..total(A)];
clock    y[1..total(A)];
register p;

--------------------------------------------------------------------------
automaton A[i] {
initially I and x[i] = 0;
  mode I{ 
    invariant True;
    when True may goto E; p := i;
  }
  mode E{ 
    invariant True;
    when p = 1 and x[i] = e1 may goto D;
    when p = 2 and x[i] = e2 may goto D;
    when p = 3 and x[i] = e3 may goto D;
    when p = 4 and x[i] = e4 may goto D;
    when p = 5 and x[i] = e5 may goto D;
    when p = 6 and x[i] = e6 may goto D;
    when p = 7 and x[i] = e7 may goto D;
    when p = 8 and x[i] = e8 may goto D;
    when p = 9 and x[i] = e9 may goto D; 
    when p = 10 and x[i] = e10 may goto D;
    when p = 11 and x[i] = e11 may goto D;
  }
  mode D{ 
    invariant True;
    when p = 1 and x[i] >= p1 may goto R; y[i] := 0;
    when p = 2 and x[i] >= p2 may goto R; y[i] := 0;
    when p = 3 and x[i] >= p3 may goto R; y[i] := 0;
    when p = 4 and x[i] >= p4 may goto R; y[i] := 0;
    when p = 5 and x[i] >= p5 may goto R; y[i] := 0;
    when p = 6 and x[i] >= p6 may goto R; y[i] := 0;
    when p = 7 and x[i] >= p7 may goto R; y[i] := 0;
    when p = 8 and x[i] >= p8 may goto R; y[i] := 0;
    when p = 9 and x[i] >= p9 may goto R; y[i] := 0;
    when p = 10 and x[i] >= p10 may goto R; y[i] := 0;
    when p = 11 and x[i] >= p11 may goto R; y[i] := 0;
  }
  mode R{
    invariant y[i] = 0;
    when p = 1 and x[i] > d1 may goto V;
    when p = 2 and x[i] > d2 may goto V;
    when p = 3 and x[i] > d3 may goto V;
    when p = 4 and x[i] > d4 may goto V;
    when p = 5 and x[i] > d5 may goto V;
    when p = 6 and x[i] > d6 may goto V;
    when p = 7 and x[i] > d7 may goto V;
    when p = 8 and x[i] > d8 may goto V;
    when p = 9 and x[i] > d9 may goto V;
    when p = 10 and x[i] > d10 may goto V;
    when p = 11 and x[i] > d11 may goto V;
    when p = 1 and x[i] <= d1 may goto I;
    when p = 2 and x[i] <= d2 may goto I;
    when p = 3 and x[i] <= d3 may goto I;
    when p = 4 and x[i] <= d4 may goto I;
    when p = 5 and x[i] <= d5 may goto I;
    when p = 6 and x[i] <= d6 may goto I;
    when p = 7 and x[i] <= d7 may goto I;
    when p = 8 and x[i] <= d8 may goto I;
    when p = 9 and x[i] <= d9 may goto I;
    when p = 10 and x[i] <= d10 may goto I;
    when p = 11 and x[i] <= d11 may goto I;
  }
  mode V{
    invariant True;
  }
}

--verify all_paths (henceforth not{(mode(A[1]) = M4) and (mode(A[2]) = M4)}
--                         and not{(mode(A[1]) = M4) and (mode(A[3]) = M4)}
--                         and not{(mode(A[2]) = M4) and (mode(A[3]) = M4)}
--                 );

manipulation

----------------------------------------
--   A user-defined sequential merge  --
----------------------------------------
--    graph g[1..3];
--
--    for(i:=1; i<4; i++) {
--      if(i = 1) {
--        g[1] := merge_graph(A[1], A[2]);
--      }
--      else {
--        g[i] := merge_graph(g[i-1], A[i+1]);
--      }
--    }
--    read_write(g[i-1]);
--    shield_clock(g[i-1]);
--    normalize_region(g[i-1]);
--
--    model_check(g[total_automata-1]);
--    print_graph(g[total_automata-1]);
----------------------------------------

----------------------------------------
--   System-defined sequential merge  --
----------------------------------------
    sequential_merge();
    read_write();
    shield_clock();
    normalize_region();
--    transition_bypass();   -- No use
--    print_graph();
