




































automata A: i=1..11;
clock    x[1..total(A)];
clock    y[1..total(A)];
register p;

--------------------------------------------------------------------------
automaton A[i] {
initially I and x[i] = 0;
  mode I{ 
    invariant True;
    when True may goto E; p := i;
  }
  mode E{ 
    invariant True;
    when p = 1 and x[i] = 2 may goto D;
    when p = 2 and x[i] = 2 may goto D;
    when p = 3 and x[i] = 2 may goto D;
    when p = 4 and x[i] = 1 may goto D;
    when p = 5 and x[i] = 3 may goto D;
    when p = 6 and x[i] = 3 may goto D;
    when p = 7 and x[i] = 3 may goto D;
    when p = 8 and x[i] = 3 may goto D;
    when p = 9 and x[i] = 4 may goto D; 
    when p = 10 and x[i] = 4 may goto D;
    when p = 11 and x[i] = 1 may goto D;
  }
  mode D{ 
    invariant True;
    when p = 1 and x[i] >= 40 may goto R; y[i] := 0;
    when p = 2 and x[i] >= 40 may goto R; y[i] := 0;
    when p = 3 and x[i] >= 20 may goto R; y[i] := 0;
    when p = 4 and x[i] >= 20 may goto R; y[i] := 0;
    when p = 5 and x[i] >= 20 may goto R; y[i] := 0;
    when p = 6 and x[i] >= 20 may goto R; y[i] := 0;
    when p = 7 and x[i] >= 20 may goto R; y[i] := 0;
    when p = 8 and x[i] >= 20 may goto R; y[i] := 0;
    when p = 9 and x[i] >= 20 may goto R; y[i] := 0;
    when p = 10 and x[i] >= 20 may goto R; y[i] := 0;
    when p = 11 and x[i] >= 10 may goto R; y[i] := 0;
  }
  mode R{
    invariant y[i] = 0;
    when p = 1 and x[i] > 80 may goto V;
    when p = 2 and x[i] > 80 may goto V;
    when p = 3 and x[i] > 20 may goto V;
    when p = 4 and x[i] > 20 may goto V;
    when p = 5 and x[i] > 20 may goto V;
    when p = 6 and x[i] > 20 may goto V;
    when p = 7 and x[i] > 20 may goto V;
    when p = 8 and x[i] > 20 may goto V;
    when p = 9 and x[i] > 20 may goto V;
    when p = 10 and x[i] > 20 may goto V;
    when p = 11 and x[i] > 10 may goto V;
    when p = 1 and x[i] <= 80 may goto I;
    when p = 2 and x[i] <= 80 may goto I;
    when p = 3 and x[i] <= 20 may goto I;
    when p = 4 and x[i] <= 20 may goto I;
    when p = 5 and x[i] <= 20 may goto I;
    when p = 6 and x[i] <= 20 may goto I;
    when p = 7 and x[i] <= 20 may goto I;
    when p = 8 and x[i] <= 20 may goto I;
    when p = 9 and x[i] <= 20 may goto I;
    when p = 10 and x[i] <= 20 may goto I;
    when p = 11 and x[i] <= 10 may goto I;
  }
  mode V{
    invariant True;
  }
}

--verify all_paths (henceforth not{(mode(A[1]) = M4) and (mode(A[2]) = M4)}
--                         and not{(mode(A[1]) = M4) and (mode(A[3]) = M4)}
--                         and not{(mode(A[2]) = M4) and (mode(A[3]) = M4)}
--                 );

manipulation

----------------------------------------
--   A user-defined sequential merge  --
----------------------------------------
--    graph g[1..3];
--
--    for(i:=1; i<4; i++) {
--      if(i = 1) {
--        g[1] := merge_graph(A[1], A[2]);
--      }
--      else {
--        g[i] := merge_graph(g[i-1], A[i+1]);
--      }
--    }
--    read_write(g[i-1]);
--    shield_clock(g[i-1]);
--    normalize_region(g[i-1]);
--
--    model_check(g[total_automata-1]);
--    print_graph(g[total_automata-1]);
----------------------------------------

----------------------------------------
--   System-defined sequential merge  --
----------------------------------------
    sequential_merge();
    read_write();
    shield_clock();
    normalize_region();
--    transition_bypass();   -- No use
--    print_graph();
