automata Client1 : i = 1, Client2 : j = 1;
clock x1, x2;
register token1, token2;

--------------------------------------------------------------------------
automaton Client1 {
initially Idle and 
          token1 = 1 and
          x1 = 0;
  mode Idle {
    invariant True;
    when x1 >= 1 and token1 = 1 may goto CS;
  }
  mode CS{
    invariant True; 
    when True may goto Idle; x1 := 0; token1 := 0; token2 := 1;
  }
}

automaton Client2 {
initially Idle and token2 = 0 and x2 = 0;
  mode Idle {
    invariant True;
    when x2 >= 1 and token2 = 1 may goto CS;
  }
  mode CS{
    invariant True; 
    when True may goto Idle; x2 := 0; token2 := 0; token1 := 1;
  }
}

manipulation

----------------------------------------
--   System-defined sequential merge  --
----------------------------------------
    sequential_merge();
    read_write();
    transition_bypass();
--    normalize_region();
--    look_ahead();
--    shield_clock();
--      pairwise_merge();
--    print_graph();
--    model_check();
----------------------------------------
