automata Client1 : i = 1, Client2 : j = 2, Client3 : k = 3;
clock x1, x2, x3;
register token1, token2, token3;

--------------------------------------------------------------------------
automaton Client1 {
initially Idle and 
          token1 = 1 and
          x1 = 0;
  mode Idle {
    invariant True;
    when x1 >= 1 and token1 = 1 may goto CS;
  }
  mode CS{
    invariant True; 
    when token1 = 1 may goto Idle; x1 := 0; token1 := 0; token2 := 1;
  }
}

automaton Client2 {
initially Idle and token2 = 0 and x2 = 0;
  mode Idle {
    invariant True;
    when x2 >= 1 and token2 = 1 may goto CS;
  }
  mode CS{
    invariant True; 
    when token2 = 1 may goto Idle; x2 := 0; token2 := 0; token3 := 1;
  }
}

automaton Client3 {
initially Idle and token3 = 0 and x3 = 0;
  mode Idle {
    invariant True;
    when x3 >= 1 and token3 = 1 may goto CS;
  }
  mode CS{
    invariant True; 
    when token3 = 1 may goto Idle; x3 := 0; token3 := 0; token1 := 1;
  }
}

manipulation

----------------------------------------
--   System-defined sequential merge  --
----------------------------------------
    sequential_merge();
--    hide_variables();
--    shield_clock();
--    read_write();
--    transition_bypass();
--    normalize_region();
--    look_ahead();
--      pairwise_merge();
--    print_graph();
--    model_check();
