automata R1, R2, R3, R4, R5, R6, R7, R8, R9, R10, R11;

register value, op, vc, click;

--------------------------------------------------------------------------
automaton R1 {
initially M1 and value = 0 & op = 0 & vc = 0;
  mode M1 { 
    invariant True;
    when click = 0 & value = 0 may goto M1; value := 17;
    when click = 10 & value = 0 may goto M1; value := 17; 
                                                         vc:=10;
    when click = 0 & value = 17 may goto M1; value := 17;
    when click = 10 & value = 17 may goto M1; value := 17; 
                                                         vc:=10;
  }
}

automaton R2 {
initially M2 and value = 0 & op = 0 & vc = 0;
  mode M2 { 
    invariant True;
    when click = 0 & value = 11 may goto M2; value := 17; vc := 0;
    when click = 10 & value = 11 may goto M2; value := 17; vc := 0;
    when click = 0 & value = 12 may goto M2; value := 17; vc := 0;
    when click = 10 & value = 12 may goto M2; value := 17; vc := 0;
    when click = 0 & value = 13 may goto M2; value := 17; vc := 0;
    when click = 10 & value = 13 may goto M2; value := 17; vc := 0;
    when click = 0 & value = 14 may goto M2; value := 17; vc := 0;
    when click = 10 & value = 14 may goto M2; value := 17; vc := 0;
  }
}

automaton R3 {
initially M3 and value = 0 & op = 0 & vc = 0;
  mode M3 { 
    invariant True;
    when click = 16 may goto M3; value := 0; op := 0; vc := 0;
  }
}

automaton R4 {
initially M4 and value = 0 & op = 0 & vc = 0;
  mode M4 { 
    invariant True;
    when click = 11 & value = 17 may goto M4; vc := 0; op := 11;
  }
}

automaton R5 {
initially M5 and value = 0 & op = 0 & vc = 0;
  mode M5 { 
    invariant True;
    when click = 12 & value = 17 may goto M5; vc := 0; op := 12;
  }
}

automaton R6 {
initially M6 and value = 0 & op = 0 & vc = 0;
  mode M6 { 
    invariant True;
    when click = 13 & value = 17 may goto M6; vc := 0; op := 13;
  }
}

automaton R7 {
initially M7 and value = 0 & op = 0 & vc = 0;
  mode M7 { 
    invariant True;
    when click = 14 & value = 17 may goto M7; vc := 0; op := 14;
  }
}

automaton R8 {
initially M8 and value = 0 & op = 0 & vc = 0;
  mode M8 { 
    invariant True;
    when click = 15 & op = 11 may goto M8; value := 11; op := 0;
  }
}

automaton R9 {
initially M9 and value = 0 & op = 0 & vc = 0;
  mode M9 { 
    invariant True;
    when click = 15 & op = 12 may goto M9; value := 12; op := 0;
  }
}

automaton R10 {
initially M10 and value = 0 & op = 0 & vc = 0;
  mode M10 { 
    invariant True;
    when click = 15 & op = 13 may goto M10; value := 13; op := 0;
  }
}

automaton R11 {
initially M11 and value = 0 & op = 0 & vc = 0;
  mode M11 { 
    invariant True;
    when click = 15 & op = 14 & vc = 10 may goto M11; value := 14; op := 0;
  }
}

manipulation
    sequential_merge();
    read_write();
    shield_variables();
--    shield_clock();
--    normalize_region();
--    transition_bypass();
--    print_graph();
--    model_check();
