total_automata 14;
clock x[1..14], y[1..14];
register lock, lock2;

--------------------------------------------------------------------------
automaton A[i] {
initially M1 and x[i]=0 and lock=0;
  mode M1 { 
    invariant x[i] + 5 <= y[i] and x[i] < 5 and ~(lock < 1) & lock != 2;
    when x[i] > 4 may goto M2; x[i] := 0; y[i] := 0;
    when x[i] > 5 may goto M3; x[i] := 1; lock := 0;
  }
  mode M2{ 
    invariant x[i] <= y[i] - 5 and x[i] < 5 and lock = i & (lock2 = i);
    when x[i] > 4 may goto M1; x[i] := 0; y[i] := 0;
    when x[i] > 5 may goto M3; x[i] := 1; lock := 0;
  }
  mode M3{ 
    invariant y[i] - 5 >= x[i] and y[i] < 5 and (lock = i) | (lock2 = i); 
    when x[i] > 4 may goto M2; x[i] := 0; lock := i;
    when x[i] > 5 may goto M3; x[i] := 1; lock := 0;
  }
}
