automata Entry, p2p6, TS, DS, IG, PE1;

clock Pt4, Pt3, Pt2, Pt1, Tt1, Cx1;


automaton PE1 {
synclabs sSp2,sSp3,sSp6,sEp6,sEp3,sEp2;
initially IDLE and Pt4=0;
mode IDLE {
 invariant True ;
          when True sync sSp2  may goto p2;
                  Pt4 := 0;
          when True sync sSp3  may goto p3;
                  Pt4 := 0;
          when True sync sSp6  may goto p6;
                  Pt4 := 0;
}
mode p6 {
 invariant Pt4 >= 0 and Pt4 <=4 ;
          when Pt4 = 4 sync sEp6  may goto IDLE;
                  Pt4 :=0;
}
mode p3 {
 invariant Pt4 >= 0 and Pt4 <=30 ;
          when Pt4 = 30 sync sEp3  may goto IDLE;
                  Pt4 :=0;
}
mode p2 {
 invariant Pt4 >= 0 and Pt4 <=20 ;
          when Pt4 = 20 sync sEp2  may goto IDLE;
                  Pt4 :=0;
}
}

automaton IG {
synclabs sSp4,sSp5,sEp5,sEp4;
initially IDLE and Pt3=0;
mode IDLE {
 invariant True ;
          when True sync sSp4  may goto p4;
                  Pt3 := 0;
          when True sync sSp5  may goto p5;
                  Pt3 := 0;
}
mode p5 {
 invariant Pt3 >= 0 and Pt3 <=25 ;
          when Pt3 = 25 sync sEp5  may goto IDLE;
                  Pt3 :=0;
}
mode p4 {
 invariant Pt3 >= 0 and Pt3 <=600 ;
          when Pt3 = 600 sync sEp4  may goto IDLE;
                  Pt3 :=0;
}
}

automaton DS {
synclabs sSp7,sEp7;
initially IDLE and Pt2=0;
mode IDLE {
 invariant True ;
          when True sync sSp7  may goto p7;
                  Pt2 := 0;
}
mode p7 {
 invariant Pt2 >= 0 and Pt2 <=10 ;
          when Pt2 = 10 sync sEp7  may goto IDLE;
                  Pt2 :=0;
}
}

automaton TS {
synclabs sSp1,sEp1;
initially IDLE and Pt1=0;
mode IDLE {
 invariant True ;
          when True sync sSp1  may goto p1;
                  Pt1 := 0;
}
mode p1 {
 invariant Pt1 >= 0 and Pt1 <=100 ;
          when Pt1 = 100 sync sEp1  may goto IDLE;
                  Pt1 :=0;
}
}

automaton Entry {
synclabs sSp1,sEp1,sSp2,sEp2,sFp22,sSp3,sEp3,sSp4,sEp4,sSp5,sEp5,sJEND2;
initially START and  Tt1=0 and Cx1=0;
mode START {
 invariant True ;
          when True sync sSp1  may goto Sp1;
}
mode Sp1 {
 invariant True ;
          when True sync sEp1  may goto Ep1;
}
mode Ep1 {
 invariant True ;
          when True sync sSp2 may goto Sp2;
}
mode Sp2 {
 invariant True ;
          when True sync sEp2  may goto Ep2;
}
mode Ep2 {
 invariant True ;
          when True sync sFp22  may goto Fp22;
}
mode Fp22 {
 invariant True ;
          when True sync sSp3 may goto Sp3;
}
mode Sp3 {
 invariant True ;
          when True sync sEp3  may goto Ep3;
}
mode Ep3 {
 invariant True ;
          when True sync sSp4 may goto Sp4;
}
mode Sp4 {
 invariant True ;
          when True sync sEp4  may goto Ep4;
}
mode Ep4 {
 invariant True ;
          when True sync sSp5 may goto Sp5;
}
mode Sp5 {
 invariant True ;
          when True sync sEp5  may goto Ep5;
}
mode Ep5 {
 invariant True ;
          when True sync sJEND2  may goto JEND2;
                  Cx1:=0;
}
mode JEND2 {
 invariant  Cx1 = 0 ;
          when Tt1 <= 1900 may goto DELAY;
          when Tt1 > 1900 may goto lERROR;
}
mode DELAY {
 invariant Tt1 <=2000 ;
          when Tt1=2000  may goto START;
                  Tt1 := 0;
}
mode lERROR {
 invariant True ;
          when False may goto lERROR;
}
}

automaton p2p6 {
synclabs sFp22,sSp6,sEp6,sSp7,sEp7,sJEND2;
initially IDLE ;
mode IDLE {
 invariant True ;
          when True sync sFp22 may goto START;
}
mode START {
 invariant True ;
          when True sync sSp6 may goto Sp6;
}
mode Sp6 {
 invariant True ;
          when True sync sEp6  may goto Ep6;
}
mode Ep6 {
 invariant True ;
          when True sync sSp7 may goto Sp7;
}
mode Sp7 {
 invariant True ;
          when True sync sEp7  may goto Ep7;
}
mode Ep7 {
 invariant True ;
          when True sync sJEND2 may goto IDLE;
}
}

 manipulation 
  sequential_merge();
 shield_clock();
