automata Exit, p9p12, TC, DS, PE2, OG;

clock Pt4, Pt3, Pt2, Pt1, Tt1, Cx1;


automaton PE2 {
synclabs sSp9,sSp12,sEp12,sEp9;
initially IDLE and Pt4=0;
mode IDLE {
 invariant True ;
          when True sync sSp9  may goto p9;
                  Pt4 := 0;
          when True sync sSp12  may goto p12;
                  Pt4 := 0;
}
mode p12 {
 invariant Pt4 >= 0 and Pt4 <=4 ;
          when Pt4 = 4 sync sEp12  may goto IDLE;
                  Pt4 :=0;
}
mode p9 {
 invariant Pt4 >= 0 and Pt4 <=300 ;
          when Pt4 = 300 sync sEp9  may goto IDLE;
                  Pt4 :=0;
}
}

automaton OG {
synclabs sSp10,sSp11,sEp11,sEp10;
initially IDLE and Pt3=0;
mode IDLE {
 invariant True ;
          when True sync sSp10  may goto p10;
                  Pt3 := 0;
          when True sync sSp11  may goto p11;
                  Pt3 := 0;
}
mode p11 {
 invariant Pt3 >= 0 and Pt3 <=25 ;
          when Pt3 = 25 sync sEp11  may goto IDLE;
                  Pt3 :=0;
}
mode p10 {
 invariant Pt3 >= 0 and Pt3 <=600 ;
          when Pt3 = 600 sync sEp10  may goto IDLE;
                  Pt3 :=0;
}
}

automaton DS {
synclabs sSp13,sEp13;
initially IDLE and Pt2=0;
mode IDLE {
 invariant True ;
          when True sync sSp13  may goto p13;
                  Pt2 := 0;
}
mode p13 {
 invariant Pt2 >= 0 and Pt2 <=10 ;
          when Pt2 = 10 sync sEp13  may goto IDLE;
                  Pt2 :=0;
}
}

automaton TC {
synclabs sSp8,sEp8;
initially IDLE and Pt1=0;
mode IDLE {
 invariant True ;
          when True sync sSp8  may goto p8;
                  Pt1 := 0;
}
mode p8 {
 invariant Pt1 >= 0 and Pt1 <=100 ;
          when Pt1 = 100 sync sEp8  may goto IDLE;
                  Pt1 :=0;
}
}

automaton Exit {
synclabs sSp8,sEp8,sSp9,sEp9,sFp92,sSp10,sEp10,sSp11,sEp11,sJEND2;
initially START and  Tt1=0 and Cx1=0;
mode START {
 invariant True ;
          when True sync sSp8  may goto Sp8;
}
mode Sp8 {
 invariant True ;
          when True sync sEp8  may goto Ep8;
}
mode Ep8 {
 invariant True ;
          when True sync sSp9 may goto Sp9;
}
mode Sp9 {
 invariant True ;
          when True sync sEp9  may goto Ep9;
}
mode Ep9 {
 invariant True ;
          when True sync sFp92  may goto Fp92;
}
mode Fp92 {
 invariant True ;
          when True sync sSp10 may goto Sp10;
}
mode Sp10 {
 invariant True ;
          when True sync sEp10  may goto Ep10;
}
mode Ep10 {
 invariant True ;
          when True sync sSp11 may goto Sp11;
}
mode Sp11 {
 invariant True ;
          when True sync sEp11  may goto Ep11;
}
mode Ep11 {
 invariant True ;
          when True sync sJEND2  may goto JEND2;
                  Cx1:=0;
}
mode JEND2 {
 invariant  Cx1 = 0 ;
          when Tt1 <= 1850 may goto DELAY;
          when Tt1 > 1850 may goto lERROR;
}
mode DELAY {
 invariant Tt1 <=2000 ;
          when Tt1=2000  may goto START;
                  Tt1 := 0;
}
mode lERROR {
 invariant True ;
          when False may goto lERROR;
}
}

automaton p9p12 {
synclabs sFp92,sSp12,sEp12,sSp13,sEp13,sJEND2;
initially IDLE ;
mode IDLE {
 invariant True ;
          when True sync sFp92 may goto START;
}
mode START {
 invariant True ;
          when True sync sSp12 may goto Sp12;
}
mode Sp12 {
 invariant True ;
          when True sync sEp12  may goto Ep12;
}
mode Ep12 {
 invariant True ;
          when True sync sSp13 may goto Sp13;
}
mode Sp13 {
 invariant True ;
          when True sync sEp13  may goto Ep13;
}
mode Ep13 {
 invariant True ;
          when True sync sJEND2 may goto IDLE;
}
}

 manipulation 
  sequential_merge();
 shield_clock();
