automata Entry, Exit, p9p12, p2p6, PE1, PE2, IG, OG, DS, TS, TC;

clock Pt7, Pt6, Pt5, Pt4, Pt3, Pt2, Pt1, Tt1, Cx1, Tt2, Cx2;


automaton PE1 {
synclabs sSp2,sEp2,sSp3,sEp3,sSp6,sEp6;
initially IDLE and Pt7=0;
mode IDLE {
 invariant True ;
          when True sync sSp2  may goto p2;
                  Pt7 := 0;
}
mode p2 {
 invariant Pt7 >= 0 and Pt7 <=20 ;
          when Pt7 = 20 sync sEp2  may goto Ip2;
                  Pt7 :=0;
}
mode Ip2 {
 invariant True ;
          when True sync sSp3  may goto p3;
                  Pt7 := 0;
}
mode p3 {
 invariant Pt7 >= 0 and Pt7 <=30 ;
          when Pt7 = 30 sync sEp3  may goto Ip3;
                  Pt7 :=0;
}
mode Ip3 {
 invariant True ;
          when True sync sSp6  may goto p6;
                  Pt7 := 0;
}
mode p6 {
 invariant Pt7 >= 0 and Pt7 <=4 ;
          when Pt7 = 4 sync sEp6  may goto IDLE;
                  Pt7 :=0;
}
}

automaton TC {
synclabs sSp8,sEp8;
initially IDLE and Pt6=0;
mode IDLE {
 invariant True ;
          when True sync sSp8  may goto p8;
                  Pt6 := 0;
}
mode p8 {
 invariant Pt6 >= 0 and Pt6 <=100 ;
          when Pt6 = 100 sync sEp8  may goto IDLE;
                  Pt6 :=0;
}
}

automaton PE2 {
synclabs sSp9,sEp9,sSp12,sEp12;
initially IDLE and Pt5=0;
mode IDLE {
 invariant True ;
          when True sync sSp9  may goto p9;
                  Pt5 := 0;
}
mode p9 {
 invariant Pt5 >= 0 and Pt5 <=300 ;
          when Pt5 = 300 sync sEp9  may goto Ip9;
                  Pt5 :=0;
}
mode Ip9 {
 invariant True ;
          when True sync sSp12  may goto p12;
                  Pt5 := 0;
}
mode p12 {
 invariant Pt5 >= 0 and Pt5 <=4 ;
          when Pt5 = 4 sync sEp12  may goto IDLE;
                  Pt5 :=0;
}
}

automaton IG {
synclabs sSp4,sEp4,sSp5,sEp5;
initially IDLE and Pt4=0;
mode IDLE {
 invariant True ;
          when True sync sSp4  may goto p4;
                  Pt4 := 0;
}
mode p4 {
 invariant Pt4 >= 0 and Pt4 <=600 ;
          when Pt4 = 600 sync sEp4  may goto Ip4;
                  Pt4 :=0;
}
mode Ip4 {
 invariant True ;
          when True sync sSp5  may goto p5;
                  Pt4 := 0;
}
mode p5 {
 invariant Pt4 >= 0 and Pt4 <=25 ;
          when Pt4 = 25 sync sEp5  may goto IDLE;
                  Pt4 :=0;
}
}

automaton OG {
synclabs sSp10,sEp10,sSp11,sEp11;
initially IDLE and Pt3=0;
mode IDLE {
 invariant True ;
          when True sync sSp10  may goto p10;
                  Pt3 := 0;
}
mode p10 {
 invariant Pt3 >= 0 and Pt3 <=600 ;
          when Pt3 = 600 sync sEp10  may goto Ip10;
                  Pt3 :=0;
}
mode Ip10 {
 invariant True ;
          when True sync sSp11  may goto p11;
                  Pt3 := 0;
}
mode p11 {
 invariant Pt3 >= 0 and Pt3 <=25 ;
          when Pt3 = 25 sync sEp11  may goto IDLE;
                  Pt3 :=0;
}
}

automaton DS {
synclabs sSp7,sEp7,sSp13,sEp13;
initially IDLE and Pt2=0;
mode IDLE {
 invariant True ;
          when True sync sSp7  may goto p7;
                  Pt2 := 0;
}
mode p7 {
 invariant Pt2 >= 0 and Pt2 <=10 ;
          when Pt2 = 10 sync sEp7  may goto Ip7;
                  Pt2 :=0;
}
mode Ip7 {
 invariant True ;
          when True sync sSp13  may goto p13;
                  Pt2 := 0;
}
mode p13 {
 invariant Pt2 >= 0 and Pt2 <=10 ;
          when Pt2 = 10 sync sEp13  may goto IDLE;
                  Pt2 :=0;
}
}

automaton TS {
synclabs sSp1,sEp1;
initially IDLE and Pt1=0;
mode IDLE {
 invariant True ;
          when True sync sSp1  may goto p1;
                  Pt1 := 0;
}
mode p1 {
 invariant Pt1 >= 0 and Pt1 <=100 ;
          when Pt1 = 100 sync sEp1  may goto IDLE;
                  Pt1 :=0;
}
}

automaton Entry {
synclabs sSp1,sEp1,sSp2,sEp2,sFp22,sSp3,sEp3,sSp4,sEp4,sSp5,sEp5,sJEND2;
initially START and  Tt1=0 and Cx1=0;
mode START {
 invariant True ;
          when True sync sSp1  may goto Sp1;
}
mode Sp1 {
 invariant True ;
          when True sync sEp1  may goto Ep1;
}
mode Ep1 {
 invariant True ;
          when True sync sSp2 may goto Sp2;
}
mode Sp2 {
 invariant True ;
          when True sync sEp2  may goto Ep2;
}
mode Ep2 {
 invariant True ;
          when True sync sFp22  may goto Fp22;
}
mode Fp22 {
 invariant True ;
          when True sync sSp3 may goto Sp3;
}
mode Sp3 {
 invariant True ;
          when True sync sEp3  may goto Ep3;
}
mode Ep3 {
 invariant True ;
          when True sync sSp4 may goto Sp4;
}
mode Sp4 {
 invariant True ;
          when True sync sEp4  may goto Ep4;
}
mode Ep4 {
 invariant True ;
          when True sync sSp5 may goto Sp5;
}
mode Sp5 {
 invariant True ;
          when True sync sEp5  may goto Ep5;
}
mode Ep5 {
 invariant True ;
          when True sync sJEND2  may goto JEND2;
                  Cx1:=0;
}
mode JEND2 {
 invariant  Cx1 = 0 ;
          when Tt1 <= 1900 may goto DELAY;
          when Tt1 > 1900 may goto lERROR;
}
mode DELAY {
 invariant Tt1 <=2000 ;
          when Tt1=2000  may goto START;
                  Tt1 := 0;
}
mode lERROR {
 invariant True ;
          when False may goto lERROR;
}
}

automaton p2p6 {
synclabs sFp22,sSp6,sEp6,sSp7,sEp7,sJEND2;
initially IDLE ;
mode IDLE {
 invariant True ;
          when True sync sFp22 may goto START;
}
mode START {
 invariant True ;
          when True sync sSp6 may goto Sp6;
}
mode Sp6 {
 invariant True ;
          when True sync sEp6  may goto Ep6;
}
mode Ep6 {
 invariant True ;
          when True sync sSp7 may goto Sp7;
}
mode Sp7 {
 invariant True ;
          when True sync sEp7  may goto Ep7;
}
mode Ep7 {
 invariant True ;
          when True sync sJEND2 may goto IDLE;
}
}

automaton Exit {
synclabs sSp8,sEp8,sSp9,sEp9,sFp92,sSp10,sEp10,sSp11,sEp11,sJEND2;
initially START and  Tt2=0 and Cx2=0;
mode START {
 invariant True ;
          when True sync sSp8  may goto Sp8;
}
mode Sp8 {
 invariant True ;
          when True sync sEp8  may goto Ep8;
}
mode Ep8 {
 invariant True ;
          when True sync sSp9 may goto Sp9;
}
mode Sp9 {
 invariant True ;
          when True sync sEp9  may goto Ep9;
}
mode Ep9 {
 invariant True ;
          when True sync sFp92  may goto Fp92;
}
mode Fp92 {
 invariant True ;
          when True sync sSp10 may goto Sp10;
}
mode Sp10 {
 invariant True ;
          when True sync sEp10  may goto Ep10;
}
mode Ep10 {
 invariant True ;
          when True sync sSp11 may goto Sp11;
}
mode Sp11 {
 invariant True ;
          when True sync sEp11  may goto Ep11;
}
mode Ep11 {
 invariant True ;
          when True sync sJEND2  may goto JEND2;
                  Cx2:=0;
}
mode JEND2 {
 invariant  Cx2 = 0 ;
          when Tt2 <= 1900 may goto DELAY;
          when Tt2 > 1900 may goto lERROR;
}
mode DELAY {
 invariant Tt2 <=2000 ;
          when Tt2=2000  may goto START;
                  Tt2 := 0;
}
mode lERROR {
 invariant True ;
          when False may goto lERROR;
}
}

automaton p9p12 {
synclabs sFp92,sSp12,sEp12,sSp13,sEp13,sJEND2;
initially IDLE ;
mode IDLE {
 invariant True ;
          when True sync sFp92 may goto START;
}
mode START {
 invariant True ;
          when True sync sSp12 may goto Sp12;
}
mode Sp12 {
 invariant True ;
          when True sync sEp12  may goto Ep12;
}
mode Ep12 {
 invariant True ;
          when True sync sSp13 may goto Sp13;
}
mode Sp13 {
 invariant True ;
          when True sync sEp13  may goto Ep13;
}
mode Ep13 {
 invariant True ;
          when True sync sJEND2 may goto IDLE;
}
}

 manipulation 
  sequential_merge();
  shield_clock();
  transition_bypass();
