var
Pt7 	: analog;
Pt6 	: analog;
Pt5 	: analog;
Pt4 	: analog;
Pt3 	: analog;
Pt2 	: analog;
Pt1 	: analog;
Tt1 	: clock;
Cx1 	: clock;
Tt2 	: clock;
Cx2 	: clock;

automaton PE1
synclabs :sSp2,sEp2,sSp3,sEp3,sSp6,sEp6;
initially IDLE & Pt7=0;
loc IDLE: while True wait {dPt7=0}
          when asap sync sSp2  do {Pt7' = 0} goto p2;
loc p2: while Pt7 >= 0 & Pt7 <=20 wait {dPt7 = 1}
          when Pt7 = 20 sync sEp2  do {Pt7' =0} goto Ip2;
loc Ip2: while True wait {dPt7=0}
          when asap sync sSp3  do {Pt7' = 0} goto p3;
loc p3: while Pt7 >= 0 & Pt7 <=30 wait {dPt7 = 1}
          when Pt7 = 30 sync sEp3  do {Pt7' =0} goto Ip3;
loc Ip3: while True wait {dPt7=0}
          when asap sync sSp6  do {Pt7' = 0} goto p6;
loc p6: while Pt7 >= 0 & Pt7 <=4 wait {dPt7 = 1}
          when Pt7 = 4 sync sEp6  do {Pt7' =0} goto IDLE;
end

automaton TC
synclabs :sSp8,sEp8;
initially IDLE & Pt6=0;
loc IDLE: while True wait {dPt6=0}
          when asap sync sSp8  do {Pt6' = 0} goto p8;
loc p8: while Pt6 >= 0 & Pt6 <=100 wait {dPt6 = 1}
          when Pt6 = 100 sync sEp8  do {Pt6' =0} goto IDLE;
end

automaton PE2
synclabs :sSp9,sEp9,sSp12,sEp12;
initially IDLE & Pt5=0;
loc IDLE: while True wait {dPt5=0}
          when asap sync sSp9  do {Pt5' = 0} goto p9;
loc p9: while Pt5 >= 0 & Pt5 <=300 wait {dPt5 = 1}
          when Pt5 = 300 sync sEp9  do {Pt5' =0} goto Ip9;
loc Ip9: while True wait {dPt5=0}
          when asap sync sSp12  do {Pt5' = 0} goto p12;
loc p12: while Pt5 >= 0 & Pt5 <=4 wait {dPt5 = 1}
          when Pt5 = 4 sync sEp12  do {Pt5' =0} goto IDLE;
end

automaton IG
synclabs :sSp4,sEp4,sSp5,sEp5;
initially IDLE & Pt4=0;
loc IDLE: while True wait {dPt4=0}
          when asap sync sSp4  do {Pt4' = 0} goto p4;
loc p4: while Pt4 >= 0 & Pt4 <=600 wait {dPt4 = 1}
          when Pt4 = 600 sync sEp4  do {Pt4' =0} goto Ip4;
loc Ip4: while True wait {dPt4=0}
          when asap sync sSp5  do {Pt4' = 0} goto p5;
loc p5: while Pt4 >= 0 & Pt4 <=25 wait {dPt4 = 1}
          when Pt4 = 25 sync sEp5  do {Pt4' =0} goto IDLE;
end

automaton OG
synclabs :sSp10,sEp10,sSp11,sEp11;
initially IDLE & Pt3=0;
loc IDLE: while True wait {dPt3=0}
          when asap sync sSp10  do {Pt3' = 0} goto p10;
loc p10: while Pt3 >= 0 & Pt3 <=600 wait {dPt3 = 1}
          when Pt3 = 600 sync sEp10  do {Pt3' =0} goto Ip10;
loc Ip10: while True wait {dPt3=0}
          when asap sync sSp11  do {Pt3' = 0} goto p11;
loc p11: while Pt3 >= 0 & Pt3 <=25 wait {dPt3 = 1}
          when Pt3 = 25 sync sEp11  do {Pt3' =0} goto IDLE;
end

automaton DS
synclabs :sSp7,sEp7,sSp13,sEp13;
initially IDLE & Pt2=0;
loc IDLE: while True wait {dPt2=0}
          when asap sync sSp7  do {Pt2' = 0} goto p7;
loc p7: while Pt2 >= 0 & Pt2 <=10 wait {dPt2 = 1}
          when Pt2 = 10 sync sEp7  do {Pt2' =0} goto Ip7;
loc Ip7: while True wait {dPt2=0}
          when asap sync sSp13  do {Pt2' = 0} goto p13;
loc p13: while Pt2 >= 0 & Pt2 <=10 wait {dPt2 = 1}
          when Pt2 = 10 sync sEp13  do {Pt2' =0} goto IDLE;
end

automaton TS
synclabs :sSp1,sEp1;
initially IDLE & Pt1=0;
loc IDLE: while True wait {dPt1=0}
          when asap sync sSp1  do {Pt1' = 0} goto p1;
loc p1: while Pt1 >= 0 & Pt1 <=100 wait {dPt1 = 1}
          when Pt1 = 100 sync sEp1  do {Pt1' =0} goto IDLE;
end

automaton Entry
synclabs :sSp1,sEp1,sSp2,sEp2,sFp22,sSp3,sEp3,sSp4,sEp4,sSp5,sEp5,sJEND2;
initially START & Tt1=0 & Cx1=0;
loc START: while True wait {}
          when asap sync sSp1  do {} goto Sp1;
loc Sp1: while True wait {}
          when True sync sEp1  do {} goto Ep1;
loc Ep1: while True wait {}
          when asap sync sSp2 do {} goto Sp2;
loc Sp2: while True wait {}
          when True sync sEp2  do {} goto Ep2;
loc Ep2: while True wait {}
          when asap sync sFp22  do {} goto Fp22;
loc Fp22: while True wait {}
          when asap sync sSp3 do {} goto Sp3;
loc Sp3: while True wait {}
          when True sync sEp3  do {} goto Ep3;
loc Ep3: while True wait {}
          when asap sync sSp4 do {} goto Sp4;
loc Sp4: while True wait {}
          when True sync sEp4  do {} goto Ep4;
loc Ep4: while True wait {}
          when asap sync sSp5 do {} goto Sp5;
loc Sp5: while True wait {}
          when True sync sEp5  do {} goto Ep5;
loc Ep5: while True wait {}
          when asap sync sJEND2  do {Cx1' = 0} goto JEND2;
loc JEND2: while  Cx1 = 0 wait {}
          when Tt1 <= 1900 do {} goto DELAY;
          when Tt1 > 1900 do {} goto lERROR;
loc DELAY: while Tt1 <=2000 wait {}
          when Tt1=2000  do {Tt1' = 0} goto START;
loc lERROR: while True wait {}
          when False do {} goto lERROR;
end

automaton p2p6
synclabs :sFp22,sSp6,sEp6,sSp7,sEp7,sJEND2;
initially IDLE ;
loc IDLE: while True wait {}
          when True sync sFp22 do {} goto START;
loc START: while True wait {}
          when asap sync sSp6 do {} goto Sp6;
loc Sp6: while True wait {}
          when True sync sEp6  do {} goto Ep6;
loc Ep6: while True wait {}
          when asap sync sSp7 do {} goto Sp7;
loc Sp7: while True wait {}
          when True sync sEp7  do {} goto Ep7;
loc Ep7: while True wait {}
          when asap sync sJEND2 do {} goto IDLE;
end

automaton Exit
synclabs :sSp8,sEp8,sSp9,sEp9,sFp92,sSp10,sEp10,sSp11,sEp11,sJEND2;
initially START & Tt2=0 & Cx2=0;
loc START: while True wait {}
          when asap sync sSp8  do {} goto Sp8;
loc Sp8: while True wait {}
          when True sync sEp8  do {} goto Ep8;
loc Ep8: while True wait {}
          when asap sync sSp9 do {} goto Sp9;
loc Sp9: while True wait {}
          when True sync sEp9  do {} goto Ep9;
loc Ep9: while True wait {}
          when asap sync sFp92  do {} goto Fp92;
loc Fp92: while True wait {}
          when asap sync sSp10 do {} goto Sp10;
loc Sp10: while True wait {}
          when True sync sEp10  do {} goto Ep10;
loc Ep10: while True wait {}
          when asap sync sSp11 do {} goto Sp11;
loc Sp11: while True wait {}
          when True sync sEp11  do {} goto Ep11;
loc Ep11: while True wait {}
          when asap sync sJEND2  do {Cx2' = 0} goto JEND2;
loc JEND2: while  Cx2 = 0 wait {}
          when Tt2 <= 1850 do {} goto DELAY;
          when Tt2 > 1850 do {} goto lERROR;
loc DELAY: while Tt2 <=2000 wait {}
          when Tt2=2000  do {Tt2' = 0} goto START;
loc lERROR: while True wait {}
          when False do {} goto lERROR;
end

automaton p9p12
synclabs :sFp92,sSp12,sEp12,sSp13,sEp13,sJEND2;
initially IDLE ;
loc IDLE: while True wait {}
          when True sync sFp92 do {} goto START;
loc START: while True wait {}
          when asap sync sSp12 do {} goto Sp12;
loc Sp12: while True wait {}
          when True sync sEp12  do {} goto Ep12;
loc Ep12: while True wait {}
          when asap sync sSp13 do {} goto Sp13;
loc Sp13: while True wait {}
          when True sync sEp13  do {} goto Ep13;
loc Ep13: while True wait {}
          when asap sync sJEND2 do {} goto IDLE;
end
var
init_reg, final_reg, reached, reached_viol : region;

init_reg:= loc[PE1]=IDLE & loc[TC]=IDLE & loc[PE2]=IDLE &
 loc[IG]=IDLE & loc[OG]=IDLE & loc[DS]=IDLE &
 loc[TS]=IDLE & loc[Entry]=START & loc[p2p6]=IDLE &
 loc[Exit]=START & loc[p9p12]=IDLE &
 Pt7=0 & Pt6=0 & Pt5=0 & Pt4=0 & Pt3=0 & Pt2=0 & Pt1=0 & Tt1=0 & Tt2=0 ;
final_reg:= loc[Entry]=lERROR | loc[Exit]=lERROR ;

reached:= reach forward from init_reg endreach;

reached_viol:= reached & final_reg;
if empty (reached_viol)
  then prints "Finish";
       print reached;
  else prints "Can't satisfy";
       print trace to final_reg using reached;
endif;
