struct gor_type {
  int index;
  int count;                            /* used by 23tree */
  struct a23tree_type *parent;          /* used by 23tree */
  struct gio_link_type *gio_cycle;
  struct gis_transition_type *out_gis_trans_cycle;
  struct gis_transition_type *in_gis_trans_cycle;
  struct gor_type *next;
  struct gor_type *cnext;
} ;

struct gio_type {
  int index;
  int count;                            /* used by 23tree */
  struct a23tree_type *parent;          /* used by 23tree */
  struct mode_type *mode;
  struct clkconj_type *clk_literal;
  bdd bdd_literal;
} ;

struct gio_link_type {
  struct gio_type *gio;
  struct gio_link_type *next;
} ;

struct gor_link_type {
  struct gor_type *gor;
  struct gor_link_type *next;
} ;

struct gis_transition_type {
  int index;
  struct transition_type *tr;
  struct gor_type *gor;
  struct gis_transition_type *next;
} ;

struct generic_thread_type {
  int gor_count;
  int gis_trans_count;
  struct gor_type *starting_gor;
} ;
