#ifndef __SHIELD_H
#define __SHIELD_H

extern int EIM_THREAD;

extern int eliminate_insig(struct thread_type *);
extern int significant(struct mode_type *, struct variable_type *);
extern int sig(struct mode_type *, struct variable_type *);
extern int not_in_assign(struct variable_type *, struct transition_type *);
extern int used_in_inv(struct variable_type *, struct mode_type *);
extern struct clkconj_type *given_invariance(struct mode_type *);

extern int reduce_predicates(struct thread_type *);
extern struct clkconj_type *reduce_clkconj(struct clkconj_type *);
extern struct variable_type *clk_out_of_bound(int, struct clkconj_type *);
extern int related_clkconj(struct clkconj_type *, struct variable_type *);
extern struct clkconj_type *delete_clkconj(struct clkconj_type **,
                                           struct clkconj_type **);
extern int merge_identical_modes(struct thread_type *);
extern struct var_link_type *permuted_clocks(struct var_link_type *rc, int *perm);
extern int shield_clocks(struct thread_type *);
#endif
